
#ifndef _B_LOP_H

#define _B_LOP_H

#include "adt.h"

typedef int (*CriteriaFunc)(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4);

void Interpola(mesh* _msh, INDEX_TYPE _a, INDEX_TYPE _b, INDEX_TYPE _c, vertex* _v);

void LOP(mesh* _msh, CriteriaFunc _fnc);

void OperateFlip(mesh* _msh, INDEX_TYPE _idx);


int CrDoNothing(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4);
int CrABNCriteria(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4);
int CrJNDCriteria(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4);
int CrDLPCriteria(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4);

int LOP_OneStep(mesh* _msh, INDEX_TYPE _idx, CriteriaFunc _cf);

//vertex* VertexPoint(mesh* _msh, INDEX_TYPE _idx);

INDEX_TYPE EdgePoint(mesh* _msh, INDEX_TYPE _idx);

INDEX_TYPE EdgeNext(mesh* _msh, INDEX_TYPE _idx);

INDEX_TYPE EdgeSibl(mesh* _msh, INDEX_TYPE _idx);

double Sarlus( vertex* _v1, vertex* _v2, vertex* _v3);

#endif

