
#ifndef _B_ADT_H

#define _B_ADT_H

#include "vertex.h"

#define INDEX_TYPE long
#define COUNT_TYPE long

typedef tvertex vertex;

struct hedge
{
    INDEX_TYPE ipoint;
    INDEX_TYPE inext;
    INDEX_TYPE isibl;
    INDEX_TYPE iface;
};

struct face
{
    INDEX_TYPE iedge;
    vertex nor;
};

struct vertexdraw
{
  vertex nor;
  vertex ver;
};

struct mesh
{
    face*   aface;
    vertexdraw* avertex;
    hedge*  aedge;
    COUNT_TYPE nvertex;
    COUNT_TYPE nedge;
    COUNT_TYPE nface;
};

#endif





